{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}

uses objects, dialogs, views, drivers, app, menus, endiobj;

type TMyApp = object(TApplication)
       constructor init;
       procedure   handleEvent ( Var Event: TEvent ); Virtual;
     end;

     padialog = ^tadialog;
     tadialog = object(tdialog)
       constructor init;
     end;

Const cmueber         = 100;
      cm1             = 101;
      cm2             = 102;
      cm3             = 103;

Var MyApp : TMyApp;

constructor tadialog.init;
Var  c, cc, ccc : pointer;
     r          : trect;
Begin
  R.Assign(0,0,67,14);
  inherited Init(R, 'Ein Test');
  options:=options or ofcentered;

{ 1. Beispiel: Zwei Inputlines und ein Button, der angeht, wenn
               in der 1. oder der 2. IL etwas steht (XOR)
  1. Example:  Two Inputline and a Button, that turns on, if something
               is entered into 1. or 2. IL (XOR!!) }

  R.Assign(01,01,18,02);
  cC:=New(PsInputLine, Init(R,64));
  Insert(cc);

  R.Assign(01,02,18,03);
  C:=New(PsInputLine, Init(R,64));
  Insert(c);

  ccc:=new(prslogik,init(3,1,c,cc));
  insert(ccc);

  R.Assign(20,01,30,03);
  insert(new(prbutton,init(r,'Hallo',cm1,bfnormal,$1,1,ccc)));


{ 2. Beispiel: Eine Checkbox, die eine Inputline nebst Label
               und History ein- und ausschaltet
  2. Example:  A Checkbox, that turns on a Inputline and its label.}

  R.Assign(01,4,18,5);
  c := New(PsCheckboxes, Init(R,NewSItem('~e~inschalten',Nil)));
  Insert(c);

  R.Assign(29,4,62,5);
  C:=New(PRInputLine, Init(R, 64,1,1,c));
  Insert(c);

  r.assign(62,4,65,5);
  insert(new(prhistory,init(r,c,1)));

  R.Assign(19,4,28,5);
  Insert(New(PRLabel, Init(R, 'E~in~gabe:',c)));


{ 3. Beispiel: Einen Radiobuttenleiste, die die jeweiligen Elemente
               ein- und ausschaltet
  3. Example:  Some radiobuttons, that turn on some other elements.}

  R.Assign(01,06,24,10);
  c := New(Psradiobuttons, Init(R,
       NewSItem('Button ein/aus',
       NewSItem('Der Butten',
       NewSItem('Inputline ein/aus',
       NewSItem('Checkboxen',Nil))))));
  Insert(c);

  R.Assign(25,06,45,08);
  insert(new(prbutton,init(r,'an, wenn <- ein',cm1,bfnormal,$0,1,c)));

  R.Assign(45,06,65,08);
  insert(new(prbutton,init(r,'an, wenn <- aus',cm1,bfnormal,$0,-1,c)));

  R.Assign(25,08,65,09);
  insert(New(PRInputLine, Init(R, 64,2,1,c)));

  r.assign(05,11,23,13);
  insert(New(PRradiobuttons,Init(R,
              NewSItem('Feld ~A~',
              NewSItem('Feld ~B~',Nil)),$3,-$2,c)));

  r.assign(25,11,45,13);
  insert(New(PRCheckboxes,Init(R,
              NewSItem('Feld ~A~',
              NewSItem('Feld ~B~',Nil)),$3,$3,c)));

{ 4. Beispiel: Geht an, wenn
               1.) Schalter aus 1. an  UND
               2.) Radiobutton 1 aus 3. an
  4. Example:  Turns on, wenn
               1.) Switch from exp.1 is on AND
               2.) radiobutton 1 from exp.3 is on}

  cc:=new(prslogik,init(1,1,ccc,c));
  insert(cc);

  R.Assign(45,10,65,12);
  insert(new(prbutton,init(r,'Der Button',cm1,bfnormal,$0,1,cc)));

  selectnext(false);
end;

constructor tmyapp.init;
Var R      : TRect;
    pmenue : pmenuitem;
begin
  inherited init;

{ mensystem }
  GetExtent ( R );
  R.B.Y := R.A.Y + 1;

  pmenue:=nil;

  MenuBar := New ( PMenuBar, Init ( R, NewMenu (
    NewSubMenu ( '~Drcke F1 fr Test / Press F1 to test~',hcNoContext,
    NewMenu (
      NewItem ( '~Drcke F1 fr Test~ / ~F1 for test~','F1',kbf1,cmueber,hcNoContext,
     nil)),
     nil
    ))));
  Insert(Menubar);
end;



procedure tmyapp.handleEvent( Var Event: TEvent );
Var p : pview;
begin
  inherited HandleEvent(Event);
  If Event.What = evCommand Then Begin
     case event.command of
      cmueber             : begin
                              executedialog(new(padialog,init),nil);
                            end;
     Else Exit; End;
    ClearEvent(Event);
  End;
end;



begin
{ untergrenze freier speicher setzten }
  memory.lowmemsize:=64*1024 div 16;
  MyApp.Init;
  MyApp.Run;
  MyApp.Done;
end.

