// junkview.h : interface of the CJunkView class
//
/////////////////////////////////////////////////////////////////////////////

class CJunkView : public CEditView
{
protected: // create from serialization only
	CJunkView();
	DECLARE_DYNCREATE(CJunkView)

// Attributes
public:
	CJunkDoc* GetDocument();
	
// Operations
public:
	void DisplayCaretPosition(void);
	

// Implementation
public:
	virtual ~CJunkView();
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Printing support
protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

// Generated message map functions
protected:
	//{{AFX_MSG(CJunkView)
	afx_msg void OnUpdateEditRow(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditColumn(CCmdUI* pCmdUI);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnEditChange(void);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG	// debug version in junkview.cpp
inline CJunkDoc* CJunkView::GetDocument()
   { return (CJunkDoc*) m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
